--------------------CUSTOMIZATION SECTION--------------------
local disable_player_status_icon_blinking = true;
local slow_down_buddy_icon_blinking = true; --buddies are other players, palamutes and palicos

local timer_slowdown = 0.019; -- (0; 0.02)  will make it slower, all other values will make faster
----------------------CUSTOMIZATION END----------------------

local gui_hud_type_def = sdk.find_type_definition("snow.gui.GuiHud");
local gui_hud_update_method = gui_hud_type_def:get_method("update");

local x = 0;
local old_timer_value = 0;

local status = "OK";

sdk.hook(gui_hud_update_method, function(args)
	status = "OK";
	
	if not disable_player_status_icon_blinking and not slow_down_buddy_icon_blinking then
		return;
	end

	local gui_manager = sdk.get_managed_singleton("snow.gui.GuiManager");
	if gui_manager == nil then
		status = "No gui manager";
		return;
	end

	local gui_hud = gui_manager:call("get_refGuiHud");
	if gui_hud == nil then
		status = "No ref gui hud";
		return;
	end

	if disable_player_status_icon_blinking then
		local is_quest_player_status_icon_displayed = gui_hud:get_field("_questPlayerStatusIconDisp");
		if is_quest_player_status_icon_displayed == nil then
			status = "No is_quest_player_status_icon_displayed";
		else
			if is_quest_player_status_icon_displayed then
				gui_hud:set_field("_questPlayerStatusIconBlinkTimer", 0);
			end
		end
	end

	if slow_down_buddy_icon_blinking then
		local buddy_info_list = gui_hud:get_field("_BuddyInfoList");
		slow_down_buddy_info_list(buddy_info_list, "player");
		
		local buddy_otomo_info_list = gui_hud:get_field("_BuddyOtomoInfoList");
		slow_down_buddy_info_list(buddy_otomo_info_list, "otomo");
	end
end, function(retval) end);

re.on_draw_ui(function()
    imgui.text("[No_More_Blinking_Icons.lua] Status: " .. tostring(status));
end);

function slow_down_buddy_info_list(buddy_info_list, buddy_type)
	if buddy_info_list == nil then
		status = "No " .. buddy_type .. " info list";
		return;
	end

	local buddy_info_count = buddy_info_list:call("get_Count");
	if buddy_info_count == nil then
		status = "No " .. buddy_type .. " info list count";
		return;
	end

	for i = 0, buddy_info_count - 1 do
		local buddy_info = buddy_info_list:call("get_Item", i);
		if buddy_info == nil then
			status = "No " .. buddy_type .. " info";
			goto continue;
		end

		local buddy_name = buddy_info:get_field("BuddyName");
		if buddy_info == nil then
			status = "No " .. buddy_type .. " name";
			buddy_name = "";
		end
		local debuff_status = buddy_info:get_field("DebuffStatus");
		slow_down_status(debuff_status, buddy_type, buddy_name, "debuff");

		local buff_status = buddy_info:get_field("BuffStatus");
		slow_down_status(buff_status, buddy_type, buddy_name, "buff");
		local other_status = buddy_info:get_field("OtherStatus");
		slow_down_status(other_status, buddy_type, buddy_name, "other");
		
		::continue::
	end
end

function slow_down_status(buddy_status, buddy_type, budy_name, status_type)
	if buddy_status == nil then
		status = "No " .. buddy_type .. " " .. budy_name .. " ".. status_type .. " status";
		return;
	end

	local is_buddy_status_displayed = buddy_status:get_field("isAnimeDisp");
	if is_buddy_status_displayed == nil then
		buddy_status = "No " .. buddy_type .. " " .. budy_name .. " ".. status_type .. " status";
	elseif is_buddy_status_displayed then
		local buddy_status_timer = buddy_status:get_field("Timer");
		if buddy_status_timer == nil then
			status = "No " .. buddy_type .. " " .. budy_name .. " ".. status_type .. " status timer";
		else
			buddy_status:set_field("Timer", buddy_status_timer - timer_slowdown);
		end
	end
end
